#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <signal.h>
#include "cexp.h"
#include "sockets.h"

int checkarg(int argc, char* argv[]);
int handleoptions();
void app_cleanup();

int main(int argc, char *argv[])
{
    signal(SIGINT, app_cleanup);
    list_add("Socket server", "server", start_server);
    list_add("Socket client", "client", clientstart);
    
    printf("   _____                \n  / ____|               \n | |     _____  ___ __  \n | |    / _ \\ \\/ / '_ \\ \n | |___|  __/>  <| |_) |\n  \\_____\\___/_/\\_\\ .__/ \n                 | |    \n                 |_|    \n");
    
    // Check for argruments and if we can use them.
    int result = checkarg(argc, argv);
    if (result == 0)
        return result;
    // If the app does not get args we will display a small options menu.
    result = handleoptions();
    app_cleanup();
    return result;
}
int checkarg(int argc, char* argv[])
{
    if (argc == 2)
    {
        struct exp_data* command = get_command(argv[1]);
        if (command == NULL)
            return -1;
        return command->func_ptr(NULL);
    }
    return -1;
}

int handleoptions()
{
    PRINT_LINE("Choose a option:");
    print_list_items();
    int index;
    char inputBuffer[16];
    if (fgets(inputBuffer, 10, stdin) != inputBuffer)
    {
        TRACE_WARN("Could not get input!");
        return -1;
    }

    index = atoi(inputBuffer);
    struct exp_data* data = get_from_list(index);
    if (data == NULL)
    {
        TRACE_ERROR("Could not get required data from list!");
        return -1;
    }

    PRINT_LINE("Option: [%s] selected", data->name);

    return data->func_ptr != NULL ? data->func_ptr(NULL) : -1;
}

// Clean and exit the app.
void app_cleanup()
{
    clear_list(); // Clear the exp list.
    exit(0);
}
